DEFLNG a - z
FUNCTION PBMAIN()

DIM dat?(12)
allowed$ = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?"
DIM sym%(206)
DATA  0,0,0,0,1,1,0,0,0,1,1,0,1,1,0,0,1,0,1,0,0,0,0,0,0,0,1,1,0,0
DATA  0,0,0,0,0,0,0,0,0,0,1,0,1,1,0,1,1,0,1,0,1,1,1,1,1,0,1,0,0,0
DATA  1,0,0,1,0,0,1,1,1,1,1,0,0,0,1,0,1,0,0,0,1,1,1,1,0,1,1,0,0,1
DATA  0,0,0,1,1,0,1,0,1,0,1,0,1,0,1,1,1,1,1,0,1,0,1,0,1,1,0,1,0,1
DATA  0,1,1,1,0,0,1,0,1,1,0,1,1,1,1,0,0,0,0,1,1,0,1,1,0,0,0,1,1,1
DATA  0,1,1,1,0,1,1,1,0,0,1,0,0,0,1,1,0,1,1,0,0,1,0,0,0,1,1,1,1,1
DATA  1,0,0,1,1,0,0,0,0,1,1,0,0,0,1,0,1,1,0,1,1,1,1,0,1,0,1

'DefaultMsg$ = "0000000000001"
DefaultMsg$ = "G4JNT IO90IV"
PRINT : PRINT : PRINT
PRINT "Generate JT4 Symbols for text message of up to 13 characters" : PRINT

    PRINT
    IF COMMAND$ = "" THEN LINE INPUT  "Message    ",m$ ELSE m$ = COMMAND$
    IF m$ = "" THEN m$ = DefaultMsg$

    m$ = UCASE$(m$) + SPACE$(13)
    m$ = LEFT$(m$ , 13)

    nc1 = 0 : nc2 = 0 : nc3 = 0
    COUNT = 0
    FOR x = 1 TO LEN(m$)
        ch$ = MID$(m$ , x , 1)
        c = INSTR(allowed$ , ch$)
        IF c = 0 THEN c = 37            'or   iterate for   to just ignore them
        DECR c

        SELECT CASE x
        CASE 1,2,3,4,5
            nc1 = nc1 * 42 + c
        CASE 6,7,8,9,10
            nc2 = nc2 * 42 + c
        CASE ELSE
            nc3 = nc3 * 42 + c
        END SELECT
    NEXT x


    nc1 = nc1 * 2
    IF BIT(nc3 , 15) = 1 THEN INCR nc1
    nc2 = nc2 * 2
    IF BIT(nc3 , 16) = 1 THEN INCR nc2
    ng = (nc3 AND &h7FFF)
    BIT SET ng , 15                     'Plain text flag



            '------------- UNPACK THE MESSAGE -----------
    rng = ng AND &h7FFF
    rnc3 = rng + 32768 * BIT(nc1 , 0) + 65536 * BIT(nc2 , 0)
    rnc2 = nc2 \ 2
    rnc1 = nc1 \ 2
    COLOR 13 : PRINT rnc1 ; rnc2 ; rnc3 : COLOR 7
    regen$ = SPACE$(13)

    FOR x = 5 TO 1 STEP -1
        c = rnc1 MOD 42
        MID$(regen$ ,x , 1) = MID$(allowed$ , c + 1 , 1)
        rnc1 = rnc1 \ 42
    NEXT x

    FOR x = 10 TO 6 STEP -1
        c = rnc2 MOD 42
        MID$(regen$ ,x , 1) = MID$(allowed$ , c + 1 , 1)
        rnc2 = rnc2 \ 42
    NEXT x

    FOR x = 13 TO 11 STEP -1
        c = rnc3 MOD 42
        MID$(regen$ ,x , 1) = MID$(allowed$ , c + 1 , 1)
        rnc3 = rnc3 \ 42
    NEXT x
    COLOR 3 : PRINT "Packed message    '" ; regen$ ; "'" : COLOR 7

'----------- CONVERT to 6 BIT CHARACTERS ----------------
' Only done here as this is how its done in WSJT.   TO compare results only
    qq = nc1 : SHIFT RIGHT qq , 22 : dat?(1) = qq AND &h3F
    qq = nc1 : SHIFT RIGHT qq , 16 : dat?(2) = qq AND &h3F
    qq = nc1 : SHIFT RIGHT qq , 10 : dat?(3) = qq AND &h3F
    qq = nc1 : SHIFT RIGHT qq ,  4 : dat?(4) = qq AND &h3F

    dat?(5) = 4 * (nc1 AND &h0F)
    qq = nc2 : SHIFT RIGHT qq , 26 : dat?(5) = dat?(5) + (qq AND 3)

    qq = nc2 : SHIFT RIGHT qq , 20 : dat?(6) = qq AND &h3F
    qq = nc2 : SHIFT RIGHT qq , 14 : dat?(7) = qq AND &h3F
    qq = nc2 : SHIFT RIGHT qq ,  8 : dat?(8) = qq AND &h3F
    qq = nc2 : SHIFT RIGHT qq ,  2 : dat?(9) = qq AND &h3F

    dat?(10) = 16 * (nc2 AND 3)
    qq = ng  : SHIFT RIGHT qq , 12 : dat?(10) = dat?(10) + (qq AND &h0F)

    qq = ng  : SHIFT RIGHT qq ,  6 : dat?(11) = qq AND &h3F
    qq = ng  : dat?(12) = qq AND &h3F
    FOR x = 1 TO 12
        bn$ = BIN$(dat?(x))
        WHILE LEN(bn$) < 6 : bn$ = "0" + bn$ : WEND
        PRINT USING$( "\    \";bn$);
    NEXT
    PRINT : PRINT

'-----------  Put straight into 72 bit zero end-padded form
' for compatibility with WSPR1 encoding process

    packed$ = CHR$(nc1 \ 2^20 MOD 256)
    packed$ = packed$ + CHR$(nc1 \ 2^12 MOD 256)
    packed$ = packed$ + CHR$(nc1 \ 2^4  MOD 256)

    packed$ = packed$ + CHR$(16 * (nc1 MOD 16) + nc2 \ 2^24 MOD 16)

    packed$ = packed$ + CHR$(nc2 \ 2^16 MOD 256)
    packed$ = packed$ + CHR$(nc2 \ 2^8 MOD 256)
    packed$ = packed$ + CHR$(nc2 MOD 256)

    packed$ = packed$ + CHR$(ng \ 2^8 MOD 256)
    packed$ = packed$ + CHR$(ng MOD 256)

    packed$ = packed$ + REPEAT$(4 , CHR$(0))

    FOR j% = 1 TO 13
        c? = ASC(MID$(packed$ , j% , 1))
        PRINT USING$( "0x\\  ";HEX$(c?));
    NEXT j%
    PRINT : PRINT

'We Now have  9 bytes of packed data + 4 zero padding bytes
'.................................................................
    poly1 = -221228207      '0xF2D05351
    poly2 = -463389625      '0xE4613C47

    opstr$ = ""
    n1 = 0
    n2 = 0
    FOR j% = 1 TO 13
        ch? = ASC(MID$(packed$ , j% , 1))
        FOR b% = 7 TO 0 STEP -1
            IF BIT(ch? , b%) = 1 THEN d% = 1 ELSE d% = 0
            SHIFT LEFT n , 1
            n = n + d%
'           print FnLongHex$(n , 8) + "  ";

            CALL PARITY(n AND poly1 , even?)
            opstr$ = opstr$ + CHR$(even?)

            CALL PARITY(n AND poly2 , even?)
            opstr$ = opstr$ + CHR$(even?)
        NEXT b%
    NEXT j%

    PRINT : COLOR 3
    PRINT "Convolved data" : COLOR 7
    FOR c% = 1 TO 206
        ch% = ASC(MID$(opstr$ , c% , 1)) + 48
        PRINT CHR$(ch%);
    NEXT c%
'---------------------------------------------------------------
    PRINT : PRINT : COLOR 3
    PRINT "Interleaver output (Raw Data" : COLOR 7

    cnvstr$ = STRING$(206 , CHR$(0))
    p% = 0
    FOR i% = 0 TO 255
        FOR j% = 0 TO 7
            IF BIT (i%, j%) THEN BIT SET r%, 7 - j% ELSE BIT RESET r% , 7 - j%
        NEXT j%

        IF r% < 206 THEN
            MID$(cnvstr$ , r% + 1 , 1) = MID$(opstr$ , p% + 1 , 1)
            INCR p%
        END IF
    NEXT i%
'-----------------------------------------------------------
    cnvstr$ = CHR$(0) + cnvstr$ 'Append reference tone to make 207 symbols

    FOR c% = 1 TO 207
        ch% = ASC(MID$(cnvstr$ , c% , 1))
        PRINT USING$( "# "; ch%);
        IF c% MOD 32 = 0 THEN PRINT
    NEXT c%

    PRINT : PRINT
'----------------------------------------------------
    COLOR 3 : PRINT "Symbols after merging with sync vector" : COLOR 7
    'restore
    FOR c% = 1 TO 207
        cd$ = READ$ (c%)
        sym%(c% - 1)= VAL(cd$)
        sym%(c% - 1) = sym%(c% - 1) + 2 * ASC(MID$(cnvstr$ , c% , 1))
        PRINT USING$( "# ";sym%(c% - 1)) ;
        IF c% MOD 32 = 0 THEN PRINT
    NEXT c%
    PRINT : PRINT

    COLOR 3 : PRINT "Packed Hex for export to PIC assembly"; : COLOR 7
'........................................................
    OPEN "JT4SYMBS.INC" FOR OUTPUT AS #1
    PRINT #1 , "    ;  JT4 Symbols  generated from GENJT4     G4JNT Jul 2009"
    PRINT #1 , "    ;  Message data '" + regen$ + "'"

    ch%= 0
    FOR c% = 0 TO 206
        IF c% MOD 4 = 3 THEN                'Last one here will be 203
            ch% = ch% + sym%(c%)
            hx$ = HEX$(ch%)
            IF ch% < 16 THEN hx$ = "0" + hx$
            PRINT USING$( "\\";hx$);
            PRINT #1, USING$( "0x\\";hx$);
            IF c% MOD 32 <> 31  THEN
                PRINT ", ";
                PRINT #1, ", ";
            END IF
            ch% = 0
        ELSE
            ch% = ch% + sym%(c%)
            SHIFT LEFT ch% , 2
        END IF

        IF c% MOD 32 = 0 THEN
            PRINT
            PRINT #1, ""
            PRINT #1 , "    de  ";
        END IF
    NEXT c%

        '3 symbols remaining to align left
    SHIFT LEFT ch% , 4
    hx$ = HEX$(ch%)
    IF ch% < 16 THEN hx$ = "0" + hx$
    PRINT USING$( "\\ ";hx$);
    PRINT : PRINT
    PRINT #1, USING$( "0x\\ ";hx$);



'---------------------'UNPACK it all again to check---------------------
'  Again, only to check new algorithms

    rnc1 = dat?(1) * 2^ 22 +  _
        dat?(2) * 2^ 16 +  _
        dat?(3) * 2^ 10 +  _
        dat?(4) * 2^ 4 +  _
        dat?(5) \ 4

    rnc2 = (dat?(5) AND 3) * 2^ 26 +  _
        dat?(6) * 2^ 20 +  _
        dat?(7) * 2^ 14 +  _
        dat?(8) * 2^ 8  +  _
        dat?(9) * 2^ 2  + _
        dat?(10) \ 16
    rng = (dat?(10) AND 15) * 2^12 +  _
        dat?(11) * 2^ 6 + _
        dat?(12)





' -----------------------------------------------------------------------

END FUNCTION


SUB PARITY(m&, even?)
    even? = 0
    FOR b% = 0 TO 31
        IF BIT(m& , b%) THEN even? = 1 - even?
    NEXT b%
END SUB


FUNCTION fnLongHex$(n& , p%)
    hx$ = ""
    WHILE LEN(hx$)<= p%
        hx$ =  HEX$(n& AND &h0F) + hx$
        SHIFT RIGHT n& , 4
    WEND
    fnLongHex$ = hx$

END FUNCTION
