DEFLNG a - z
FUNCTION PBMAIN()

DIM dat?(12), Symb9%(69), opSymbs%(85)
allowed$ = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?"
sync$ = "1100100001000001000000100000000010100000000000000011001000010000010000001000000000101"

DefaultMsg$ = "G4JNT IO90IV"

cmnd$ = COMMAND$
posdbg% = INSTR(UCASE$(cmnd$), "/D")
IF posdbg% > 0 THEN debug% = -1 : cmnd$ = LEFT$(cmnd$ , posdbg% - 1)
'Should give :
'Channel symbols:
' 0 0 1 3 0 8 8 4 1 0 3 1 6 1 4 0 4 3 4 7 7 2 0 1 5 4 1 6 7 4
' 4 7 0 4 0 3 4 1 8 3 6 8 5 4 3 6 8 6 8 1 0 0 7 2 0 8 6 7 7 0
' 5 6 7 7 1 0 6 1 8 6 6 3 0 4 4 8 3 1 5 2 1 7 0 7 0

PRINT : PRINT : PRINT
PRINT "Generate JT9 Symbols for text message of up to 13 characters"
IF debug% THEN PRINT "Display all intermediate values" : PRINT

    PRINT
    IF cmnd$ = "" THEN LINE INPUT  "Message    ",m$ ELSE m$ = LEFT$(cmnd$ , 13)
    IF m$ = "" THEN m$ = DefaultMsg$   : PRINT m$

    m$ = UCASE$(m$) + SPACE$(13)
    m$ = LEFT$(m$ , 13)

    INPUT "Destination file ( JT9SYMB.INC )   ",fi$
    IF fi$ = "" THEN fi$ = "JT9SYMB.INC"
    fi$ = UCASE$(fi$)
    PRINT
    nc1 = 0 : nc2 = 0 : nc3 = 0
    COUNT = 0
    FOR x = 1 TO LEN(m$)
        ch$ = MID$(m$ , x , 1)
        c = INSTR(allowed$ , ch$)
        IF c = 0 THEN c = 37            'or   iterate for   to just ignore them
        DECR c

        SELECT CASE x
        CASE 1,2,3,4,5
            nc1 = nc1 * 42 + c
        CASE 6,7,8,9,10
            nc2 = nc2 * 42 + c
        CASE ELSE
            nc3 = nc3 * 42 + c
        END SELECT
    NEXT x


    nc1 = nc1 * 2
    IF BIT(nc3 , 15) = 1 THEN INCR nc1
    nc2 = nc2 * 2
    IF BIT(nc3 , 16) = 1 THEN INCR nc2
    ng = (nc3 AND &h7FFF)
    BIT SET ng , 15                     'Plain text flag



            '------------- UNPACK THE MESSAGE -----------
    rng = ng AND &h7FFF
    rnc3 = rng + 32768 * BIT(nc1 , 0) + 65536 * BIT(nc2 , 0)
    rnc2 = nc2 \ 2
    rnc1 = nc1 \ 2
    IF debug% THEN COLOR 13 : PRINT rnc1 ; rnc2 ; rnc3 : COLOR 7
    regen$ = SPACE$(13)

    FOR x = 5 TO 1 STEP -1
        c = rnc1 MOD 42
        MID$(regen$ ,x , 1) = MID$(allowed$ , c + 1 , 1)
        rnc1 = rnc1 \ 42
    NEXT x

    FOR x = 10 TO 6 STEP -1
        c = rnc2 MOD 42
        MID$(regen$ ,x , 1) = MID$(allowed$ , c + 1 , 1)
        rnc2 = rnc2 \ 42
    NEXT x

    FOR x = 13 TO 11 STEP -1
        c = rnc3 MOD 42
        MID$(regen$ ,x , 1) = MID$(allowed$ , c + 1 , 1)
        rnc3 = rnc3 \ 42
    NEXT x
    IF debug% THEN COLOR 3 : PRINT "Packed message    '" ; regen$ ; "'" : COLOR 7

'----------- CONVERT to 6 BIT CHARACTERS ----------------
' Only done here as this is how its done in WSJT.   TO compare results only
    qq = nc1 : SHIFT RIGHT qq , 22 : dat?(1) = qq AND &h3F
    qq = nc1 : SHIFT RIGHT qq , 16 : dat?(2) = qq AND &h3F
    qq = nc1 : SHIFT RIGHT qq , 10 : dat?(3) = qq AND &h3F
    qq = nc1 : SHIFT RIGHT qq ,  4 : dat?(4) = qq AND &h3F

    dat?(5) = 4 * (nc1 AND &h0F)
    qq = nc2 : SHIFT RIGHT qq , 26 : dat?(5) = dat?(5) + (qq AND 3)

    qq = nc2 : SHIFT RIGHT qq , 20 : dat?(6) = qq AND &h3F
    qq = nc2 : SHIFT RIGHT qq , 14 : dat?(7) = qq AND &h3F
    qq = nc2 : SHIFT RIGHT qq ,  8 : dat?(8) = qq AND &h3F
    qq = nc2 : SHIFT RIGHT qq ,  2 : dat?(9) = qq AND &h3F

    dat?(10) = 16 * (nc2 AND 3)
    qq = ng  : SHIFT RIGHT qq , 12 : dat?(10) = dat?(10) + (qq AND &h0F)

    qq = ng  : SHIFT RIGHT qq ,  6 : dat?(11) = qq AND &h3F
    qq = ng  : dat?(12) = qq AND &h3F

    FOR x = 1 TO 12
        bn$ = BIN$(dat?(x))
        WHILE LEN(bn$) < 6 : bn$ = "0" + bn$ : WEND
        IF debug% THEN PRINT USING$( "\    \";bn$);
    NEXT
    IF debug% THEN PRINT : PRINT

'-----------  Put straight into 72 bit zero end-padded form
' for compatibility with WSPR1 encoding process

    packed$ = CHR$(nc1 \ 2^20 MOD 256)
    packed$ = packed$ + CHR$(nc1 \ 2^12 MOD 256)
    packed$ = packed$ + CHR$(nc1 \ 2^4  MOD 256)

    packed$ = packed$ + CHR$(16 * (nc1 MOD 16) + nc2 \ 2^24 MOD 16)

    packed$ = packed$ + CHR$(nc2 \ 2^16 MOD 256)
    packed$ = packed$ + CHR$(nc2 \ 2^8 MOD 256)
    packed$ = packed$ + CHR$(nc2 MOD 256)

    packed$ = packed$ + CHR$(ng \ 2^8 MOD 256)
    packed$ = packed$ + CHR$(ng MOD 256)

    packed$ = packed$ + REPEAT$(4 , CHR$(0))

'    FOR j% = 1 TO 13
'        c? = ASC(MID$(packed$ , j% , 1))
'        PRINT USING$( "0x\\  ";HEX$(c?));
'    NEXT j%
'    PRINT : PRINT

'We Now have  9 bytes of packed data + 4 zero padding bytes
'.................................................................
    poly1 = -221228207      '0xF2D05351
    poly2 = -463389625      '0xE4613C47

    opstr$ = ""
    n1 = 0
    n2 = 0
    FOR j% = 1 TO 13
        ch? = ASC(MID$(packed$ , j% , 1))
        FOR b% = 7 TO 0 STEP -1
            IF BIT(ch? , b%) = 1 THEN d% = 1 ELSE d% = 0
            SHIFT LEFT n , 1
            n = n + d%
'           print FnLongHex$(n , 8) + "  ";

            CALL PARITY(n AND poly1 , even?)
            opstr$ = opstr$ + CHR$(even?)

            CALL PARITY(n AND poly2 , even?)
            opstr$ = opstr$ + CHR$(even?)
        NEXT b%
    NEXT j%
'-----------------------------------------------------------
    IF debug% THEN PRINT : COLOR 3
    IF debug% THEN PRINT "Convolved data" : COLOR 7
    FOR c% = 1 TO 206
        ch% = ASC(MID$(opstr$ , c% , 1)) + 48
        IF debug% THEN PRINT CHR$(ch%);
    NEXT c%
'---------------------------------------------------------------


    cnvstr$ = STRING$(206 , CHR$(0))
    p% = 0
    FOR i% = 0 TO 255
        FOR j% = 0 TO 7
            IF BIT (i%, j%) THEN BIT SET r%, 7 - j% ELSE BIT RESET r% , 7 - j%
        NEXT j%

        IF r% < 206 THEN
            MID$(cnvstr$ , r% + 1 , 1) = MID$(opstr$ , p% + 1 , 1)
            INCR p%
        END IF
    NEXT i%
'-----------------------------------------------------------
    IF debug% THEN PRINT : PRINT : COLOR 3
    IF debug% THEN PRINT "Interleaver output (Raw Data" : COLOR 7

      FOR c% = 1 TO 206
        ch% = ASC(MID$(cnvstr$ , c% , 1))
        IF debug% THEN PRINT USING$( "# "; ch%);
        IF c% MOD 32 = 0 AND debug% THEN PRINT
    NEXT c%
    cnvstr$ = cnvstr$ + CHR$(0)       'Pad out to length of a multiple of 3
    IF debug% THEN PRINT : PRINT
' -----------------------------------------------------------------------

    k% = 0
    FOR i% = 1 TO 69
        n% = 0
        FOR j% = 1 TO 3
            k% = k% + 1
            m% = ASC(MID$(cnvstr$, k%, 1))      '0 or 1
            SHIFT LEFT n% , 1
            n% = n% OR m%
        NEXT j%
        Symb9%(i%) = n%
    NEXT i%
'----------------
    IF debug% THEN COLOR 3: PRINT "Symbols before Gray Coding" : COLOR 7
    FOR c% = 1 TO 69
        IF debug% THEN PRINT CHR$(Symb9%(c%)+48);
    NEXT c%
    IF debug% THEN PRINT : PRINT
' -----------------------------------------------------------------------
    FOR i% = 1 TO 69
        temp% = Symb9%(i%)
        SHIFT RIGHT temp% , 1
        Symb9%(i%)= Symb9%(i%) XOR temp%
    NEXT i%

' -----------------------------------------------------------------------
    IF debug% THEN COLOR 3: PRINT "Symbols after Gray Coding" : COLOR 7
    FOR c% = 1 TO 69
        IF debug% THEN PRINT CHR$(Symb9%(c%)+48);
    NEXT c%
    IF debug% THEN PRINT : PRINT
' -----------------------------------------------------------------------
    j% = 0


    FOR i% = 1 TO 85
        IF MID$(sync$,i%,1) = "1" THEN
            opSymbs%(i%) = 0
        ELSE
            j% = j% + 1
            opSymbs%(i%) = Symb9%(j%) + 1
        END IF
    NEXT i%

' -----------------------------------------------------------------------
    IF debug% THEN COLOR 3: PRINT "Output Symbols" : COLOR 7
    FOR c% = 1 TO 85
        IF debug% THEN PRINT CHR$(opSymbs%(c%)+48);
    NEXT c%
    IF debug% THEN PRINT : PRINT
' -----------------------------------------------------------------------
   COLOR 3: PRINT "Packed Bytes for PIC assembler" : COLOR 7
   OPEN fi$ FOR OUTPUT AS #2
   PRINT #2, ";   JT9 Symbols packed two per byte.  Message:  " + m$

   FOR c% = 1 TO 85
        IF c% MOD 16 = 1 THEN
            PRINT
            PRINT #2 , ""
            PRINT "    de  ";
            PRINT #2, "    de  ";
        ELSE
            IF c% MOD 2 = 1 THEN
                PRINT ",";
                PRINT #2 , ",";
            END IF
        END IF

        x% = opSymbs%(c%)
        IF c% MOD 2 = 1 THEN      'Symbols packed two per byte
            OPByte% = 16 * x%               '  as left justified nibbles
        ELSE
            OPByte% = OPByte% + x%
            x$ = HEX$(OPByte%)
            IF OPByte% < 15 THEN x$ = "0" + x$
            PRINT USING$ (" 0x\\", x$) ;
            PRINT #2, USING$ (" 0x\\", x$);
            OPByte% = 0
        END IF
    NEXT c%

    x$ = HEX$(OPByte%)          'Final op byte is not done as we had an odd number to deal with
    IF OPByte% < 15 THEN x$ = "0" + x$
    PRINT USING$ (" 0x\\", x$) ;
    PRINT #2, USING$ (" 0x\\", x$);

    CLOSE 2
    PRINT : PRINT
    PRINT "Symbols written to ";
    COLOR 9 : PRINT fi$
    COLOR 7
    PRINT

' -----------------------------------------------------------------------

'  WHILE NOT INSTAT : WEND

' -----------------------------------------------------------------------

END FUNCTION


SUB PARITY(m&, even?)
    even? = 0
    FOR b% = 0 TO 31
        IF BIT(m& , b%) THEN even? = 1 - even?
    NEXT b%
END SUB


FUNCTION fnLongHex$(n& , p%)
    hx$ = ""
    WHILE LEN(hx$)<= p%
        hx$ =  HEX$(n& AND &h0F) + hx$
        SHIFT RIGHT n& , 4
    WEND
    fnLongHex$ = hx$

END FUNCTION
